/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: SharedObjectManagerImpl.cc
   Note: JTRON 2.0 ֥ͭȥ󥿡ե
         (Java Native method (JNI))
   Date: 1999/8/24
   Last update: 2000/3/6
*/

#ifdef JTRON_JAVAH
/*
#include <jp_gr_itron_jtron_shared_SharedObjectManagerImpl.h>
*/
#include "jti_common.h"
#include "jti_shared.h"
#include "jti_debug.h"
#else
#include <system_pkgs/jp_gr_itron_jtron_shared_SharedObjectManagerImpl.h>
#include <jti_common.h>
#include <jti_shared.h>
#include <jti_debug.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* ֥ͭȴơ֥ꥹȡʥ᡼ܥå̿ѥåȡ */
static SHO_TBL  **p_sho_list = NULL ;
#define sho_list  (*p_sho_list)

/* Local functions */
static ER recv_solist_address ();
static SHO_TBL *search_table_name ();
static void SetLock();
static void SetUnlock();

#ifdef JTRON_DEBUG
static void print_all_tables () ;
static void print_cur_table () ;
#endif

/*
   Native method's return value: 
      0: OK
     -1: ITRON system-call error
     -2: Memory allocation error
     -3: Target table not found
     -4: Timeout
     -5: Locked by other thread or task
*/

/*
   Native method: private native synchronized int
                  share_object_jtn (Sharable obj, String name) ;
*/
JNIEXPORT jint JNICALL
Java_jp_gr_itron_jtron_shared_SharedObjectManagerImpl_share_1object_1jtn
  (JNIEnv *env, jobject object, jobject sho, jstring name)
{
  static int recv_done = 0 ;
  SHO_TBL  *new_tbl = NULL ;
  SHO_TBL  *tbl = NULL ;
  T_CSEM  pk_csem ;
  ER  ercd = 0 ;
  const char *ascii_name ;
  jboolean  isCopy ;

#ifdef JTRON_DEBUG
  jclass    clazz ;
  jfieldID  fid ;
  jint      sho_data ;  /* եɥǡ */
#endif

  DPRINT("> (share) Enter NM: share_object_jtn\n");

  /* Recv shared-object-information-table-address from ITRON API */
  if (recv_done == 0) {
    DPRINT("> (share) recv_solist_address Call:\n");
    if (recv_solist_address () != E_OK) {
      return (-1) ;
    }
    DPRINT("> (share) recv_solist_address Call-Return:\n");
    recv_done = 1 ;
  }
  DPRINT1("> (share) sho_list: [%d]\n",sho_list);

  /* Create New table */
  if ((new_tbl = (SHO_TBL *)malloc (sizeof (SHO_TBL))) == NULL) {
    return (-2) ;  /* Err: malloc (Memory allocation error) */
  }
  DPRINT1("> (share) malloc OK: [%d]\n",new_tbl);

  /* Semapho ID */
  pk_csem.sematr = TA_TFIFO ;
  pk_csem.isemcnt = 1 ;
  pk_csem.maxsem = 1 ;
  /* Create semapho */
  if ((new_tbl->sho_id = (JNO)vcre_sem (&pk_csem)) < 0) {
    DPRINT1("> (share) vcre_sem Err:[%d]\n",new_tbl->sho_id);
    free (new_tbl) ;
    return (-1) ;  /* Err: vcre_sem */
  }
  DPRINT1("> (share) vcre_sem OK:[%d]\n",new_tbl->sho_id);

  /* Shared object name */
  ascii_name = env->GetStringUTFChars (name, &isCopy) ;
  strcpy (new_tbl->name, ascii_name) ;
  if (isCopy == JNI_TRUE) {
    env->ReleaseStringUTFChars (name, ascii_name) ;
  }
  DPRINT2("> (share) sho_id:[%d], name:[%s]\n",new_tbl->sho_id,new_tbl->name);
  /* Unlock */
  SetUnlock (new_tbl) ;
  DPRINT2("> (share) owner:[%d], lock_stat:[%d]\n",new_tbl->lock_owner,new_tbl->lock_stat);

#ifdef JTRON_DEBUG
  /* Get field data (name: data, type int) */
  clazz    = env->GetObjectClass (sho) ;
  fid      = env->GetFieldID (clazz, "data", "I") ;
  sho_data = env->GetIntField (sho, fid) ;
  DPRINT1("\n\n> (share) ===> data:[%d] <===\n\n",sho_data);
#endif

  /* JNI interface pointer */
  new_tbl->jni_env = env ;

  /* Create global reference */
  new_tbl->jni_obj = env->NewGlobalRef (sho) ;

  DPRINT2("> (share) env:[%d], sho:[%d]\n",new_tbl->jni_env,new_tbl->jni_obj);

  /* Next table */
  new_tbl->next = NULL ;

  /* Search end of list */
  if (sho_list == NULL) {  /* No tables */
    sho_list = new_tbl ;   /* Put first table */
    DPRINT("> (share) First table\n");
  } else {
    for (tbl = sho_list; tbl->next != NULL; tbl = tbl->next) {}
    tbl->next = new_tbl ;   /* Append new table */
    DPRINT("> (share) Append table\n");
  }

#ifdef JTRON_DEBUG
  print_all_tables () ;
#endif
  DPRINT("> (share) return OK\n");
  return (0) ;
}

/*
   Native method: private native synchronized int
                  unshare_object_jtn (String name, int tmo)
*/
JNIEXPORT jint JNICALL
Java_jp_gr_itron_jtron_shared_SharedObjectManagerImpl_unshare_1object_1jtn
  (JNIEnv *env, jobject object, jstring name, jint tmo)
{
  SHO_TBL  *tbl = NULL ;
  SHO_TBL  *prev_tbl = NULL ;
  ID  t_id = 0 ;
  ER  ercd = 0 ;
  const char *ascii_name ;
  jboolean  isCopy ;

  DPRINT("> (unshare) Enter NM: unshare_object_jtn\n");

  /* UTF -> ASCII */
  ascii_name = env->GetStringUTFChars (name, &isCopy) ;

  /* Search table by name */
  for (tbl = sho_list; tbl != NULL; tbl = tbl->next) {
    if (strcmp (tbl->name, ascii_name) == 0)  break ;
    prev_tbl = tbl ;
  }
  if (tbl == NULL) {
    DPRINT1("> (unshare) ascii_name:[%s] not found\n",ascii_name);
    return (-3) ;  /* Target table not found */
  }
  DPRINT1("> (unshare) ascii_name:[%s] found\n",ascii_name);
  DPRINT4("> (unshare) soh_list[%d],tbl[%d],next[%d],prev[%d]\n",sho_list,tbl,tbl->next,prev_tbl);

  if (isCopy == JNI_TRUE) {
    env->ReleaseStringUTFChars (name, ascii_name) ;
  }

  /* Get task ID */
  if ((ercd = get_tid (&t_id)) < 0) {
    DPRINT1("> (unshare) get_tid Err:[%d]\n",ercd);
    return (-1) ;  /* Err: get_tid */
  }
  DPRINT1("> (unshare) get_tid OK:[%d]\n",t_id);

  if (tbl->lock_stat == UNLOCK) {  /* Unlocked */
    DPRINT("> (unshare) Unlocked\n");
    SetLock (tbl, t_id, LOCK_THREAD) ;
  }
  else {  /* Locked */
    if (tbl->lock_owner == t_id) {  /* Locked by this task */
      DPRINT("> (unshare) Locked by this task\n");
      /* Unlock */
      SetUnlock (tbl) ;
      /* Return semapho */
      if ((ercd = sig_sem ((ID)(tbl->sho_id))) < 0) {
	DPRINT2("> (unshare) sig_sem Err:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
	return (-1) ;  /* Err: sig_sem */
      }
      DPRINT1("> (unshare) sig_sem OK: sho_id:[%d]\n",tbl->sho_id);
    }
    else {  /* Locked by other thread or task */
      DPRINT1("> (unshare) Locked by other thread or task: %d\n",tbl->lock_owner);
      /* Get semapho (timeout) */
      if ((ercd = twai_sem ((ID)(tbl->sho_id), (TMO)tmo)) < 0) {
	if (ercd == E_TMOUT) {
	  DPRINT2("> (unshare) twai_sem Timeout:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
	  return (-4) ;  /* Timeout: twai_sem */
	}
	DPRINT2("> (unshare) twai_sem Err:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
	return (-1) ;  /* Err: twai_sem */
      }
      DPRINT1("> (unshare) twai_sem OK: sho_id:[%d]\n",tbl->sho_id);
      /* Lock */
      SetLock (tbl, t_id, LOCK_THREAD) ;
    }
  }

  /* Delete global reference */
  env->DeleteGlobalRef (tbl->jni_obj) ;

  /* Delete semapho */
  if ((ercd = del_sem ((ID)(tbl->sho_id))) < 0) {
    DPRINT2("> (unshare) del_sem Err:[%d], sho_id:[%d]\n",ercd,tbl->sho_id);
    return (-1) ;  /* Err: del_sem */
  }
  DPRINT1("> (unshare) del_sem OK: sho_id:[%d]\n",tbl->sho_id);

  /* Delete target table */
  DPRINT("> (unshare) Delete target table\n");
  if (tbl == sho_list)  sho_list = tbl->next ;
  else                  prev_tbl->next = tbl->next ;

  DPRINT4("> (unshare) soh_list[%d],tbl[%d],next[%d],prev[%d]\n",sho_list,tbl,tbl->next,prev_tbl);

  /* Free target table */
  free (tbl) ;    /* POSIX */

#ifdef JTRON_DEBUG
  print_all_tables () ;
#endif
  DPRINT("> (unshare) return OK\n");
  return (0) ;
}

/*
   Native method: private native synchronized int
                  lock_object_jtn (String name, int tmo)
*/
JNIEXPORT jint JNICALL
Java_jp_gr_itron_jtron_shared_SharedObjectManagerImpl_lock_1object_1jtn
  (JNIEnv *env, jobject object, jstring name, jint tmo)
{
  SHO_TBL  *tbl = NULL ;
  ID  t_id = 0 ;
  ER  ercd = 0 ;
  const char *ascii_name ;
  jboolean  isCopy ;

  DPRINT("> (lock) Enter NM: lock_object_jtn\n");

  /* UTF -> ASCII */
  ascii_name = env->GetStringUTFChars (name, &isCopy) ;

  /* Search table by name */
  if ((tbl = search_table_name (ascii_name)) == NULL) {
    DPRINT1("> (lock) ascii_name:[%s] not found\n",ascii_name);
    return (-3) ;  /* Target table not found */
  }
  DPRINT1("> (lock) ascii_name:[%s] found\n",ascii_name);

#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif

  if (isCopy == JNI_TRUE) {
    env->ReleaseStringUTFChars (name, ascii_name) ;
  }

  /* Get task ID */
  if ((ercd = get_tid (&t_id)) < 0) {
    DPRINT1("> (lock) get_tid Err:[%d]\n",ercd);
    return (-1) ;  /* Err: get_tid */
  }
  DPRINT1("> (lock) get_tid OK:[%d]\n",t_id);

  if (tbl->lock_stat == UNLOCK) {  /* Unlocked */
    DPRINT("> (lock) Unlocked\n");
    /* Get semapho (timeout) */
    if ((ercd = twai_sem ((ID)(tbl->sho_id), (TMO)tmo)) < 0) {
      if (ercd == E_TMOUT) {
	DPRINT2("> (lock) twai_sem Timeout:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
	return (-4) ;  /* Timeout: twai_sem */
      }
      DPRINT2("> (lock) twai_sem Err:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
      return (-1) ;  /* Err: twai_sem */
    }
    DPRINT1("> (lock) twai_sem OK: sho_id:[%d]\n",tbl->sho_id);
    /* Lock */
    SetLock (tbl, t_id, LOCK_THREAD) ;
  }
  else {  /* Locked */
    if (tbl->lock_owner == t_id) {  /* Locked by this task */
      DPRINT1("> (lock) Locked by this task:[%d] (no effect)\n",tbl->lock_owner);
    }
    else {  /* Locked by other thread or task */
      DPRINT1("> (lock) Locked by other thread or task:[%d]\n",tbl->lock_owner);
      /* Get semapho (timeout) */
      if ((ercd = twai_sem ((ID)(tbl->sho_id), (TMO)tmo)) < 0) {
	if (ercd == E_TMOUT) {
	  DPRINT2("> (lock) twai_sem Timeout:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
	  return (-4) ;  /* Timeout: twai_sem */
	}
	DPRINT2("> (lock) twai_sem Err:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
	return (-1) ;  /* Err: twai_sem */
      }
      DPRINT1("> (lock) twai_sem OK: sho_id:[%d]\n",tbl->sho_id);
      /* Lock */
      SetLock (tbl, t_id, LOCK_THREAD) ;
    }
  }

#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif
  DPRINT("> (lock) return\n");
  return (0) ;
}

/*
   Native method: private native synchronized int
                  unlock_object_jtn (String name)
*/
JNIEXPORT jint JNICALL
Java_jp_gr_itron_jtron_shared_SharedObjectManagerImpl_unlock_1object_1jtn
  (JNIEnv *env, jobject object, jstring name)
{
  SHO_TBL  *tbl = NULL ;
  ID  t_id = 0 ;
  ER  ercd = 0 ;
  const char *ascii_name ;
  jboolean  isCopy ;

  DPRINT("> (unlock) Enter NM: unlock_object_jtn\n");

  /* UTF -> ASCII */
  ascii_name = env->GetStringUTFChars (name, &isCopy) ;

  /* Search table by name */
  if ((tbl = search_table_name (ascii_name)) == NULL) {
    DPRINT1("> (unlock) ascii_name:[%s] not found\n",ascii_name);
    return (-3) ;  /* Target table not found */
  }
  DPRINT1("> (unlock) ascii_name:[%s] found\n",ascii_name);

#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif

  if (isCopy == JNI_TRUE) {
    env->ReleaseStringUTFChars (name, ascii_name) ;
  }

  /* Get task ID */
  if ((ercd = get_tid (&t_id)) < 0) {
    DPRINT1("> (unlock) get_tid Err:[%d]\n",ercd);
    return (-1) ;  /* Err: get_tid */
  }
  DPRINT1("> (unlock) get_tid OK:[%d]\n",t_id);

  if (tbl->lock_stat == UNLOCK) {  /* Unlocked */
    DPRINT("> (unlock) Unlocked (no effect)\n");
  }
  else {  /* Locked */
    if (tbl->lock_owner == t_id) {  /* Locked by this thread */
      DPRINT1("> (unlock) Locked by this task:[%d]\n",tbl->lock_owner);
      /* Unlock */
      SetUnlock (tbl) ;
      /* Return semapho */
      if ((ercd = sig_sem ((ID)(tbl->sho_id))) < 0) {
	DPRINT2("> (unlock) sig_sem Err:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
	return (-1) ;  /* Err: sig_sem */
      }
      DPRINT1("> (unlock) sig_sem OK: sho_id:[%d]\n",tbl->sho_id);      
    }
    else {  /* Locked by other thread or task */
      DPRINT1("> (unlock) Locked by other thread or task:[%d]\n",tbl->lock_owner);
      return (-5) ;  /* Err: Locked by other task or thread */
    }
  }

#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif
  DPRINT("> (unlock) return OK\n");
  return (0) ;
}

/*
   Native method: private native synchronized int
                  funlock_object_jtn (String name)
*/
JNIEXPORT jint JNICALL
Java_jp_gr_itron_jtron_shared_SharedObjectManagerImpl_funlock_1object_1jtn
  (JNIEnv *env, jobject object, jstring name)
{
  SHO_TBL  *tbl = NULL ;
  ID  t_id = 0 ;
  ER  ercd = 0 ;
  const char *ascii_name ;
  jboolean  isCopy ;

  DPRINT("> (funlock) Enter NM: funlock_object_jtn\n");

  /* UTF -> ASCII */
  ascii_name = env->GetStringUTFChars (name, &isCopy) ;

  /* Search table by name */
  if ((tbl = search_table_name (ascii_name)) == NULL) {
    DPRINT1("> (funlock) ascii_name:[%s] not found\n",ascii_name);
    return (-3) ;  /* Target table not found */
  }
  DPRINT1("> (funlock) ascii_name:[%s] found\n",ascii_name);

#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif

  if (isCopy == JNI_TRUE) {
    env->ReleaseStringUTFChars (name, ascii_name) ;
  }

  /* Get task ID */
  if ((ercd = get_tid (&t_id)) < 0) {
    DPRINT1("> (funlock) get_tid Err:[%d]\n",ercd);
    return (-1) ;  /* Err: get_tid */
  }
  DPRINT1("> (funlock) get_tid OK:[%d]\n",t_id);

  if (tbl->lock_stat == UNLOCK) {  /* Unlocked */
    DPRINT("> (funlock) Unlocked (no effect)\n");
  }
  else {  /* Locked */
    if (tbl->lock_owner == t_id) {  /* Locked by this thread */
      DPRINT1("> (funlock) Locked by this thread:[%d]\n",tbl->lock_owner);
      /* Unlock */
      SetUnlock (tbl) ;
      /* Return semapho */
      if ((ercd = sig_sem ((ID)(tbl->sho_id))) < 0) {
	DPRINT2("> (funlock) sig_sem Err:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
	return (-1) ;  /* Err: sig_sem */
      }
      DPRINT1("> (funlock) sig_sem OK: sho_id:[%d]\n",tbl->sho_id);      
    }
    else {  /* Locked by other thread or task */
      if (tbl->lock_stat == LOCK_THREAD) {  /* Locked by other thread */
	DPRINT1("> (funlock) Locked by other thread:[%d]\n",tbl->lock_owner);
	/* Unlock */
	SetUnlock (tbl) ;
	/* Return semapho */
	if ((ercd = sig_sem ((ID)(tbl->sho_id))) < 0) {
	  DPRINT2("> (funlock) sig_sem Err:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
	  return (-1) ;  /* Err: sig_sem */
	}
	DPRINT1("> (funlock) sig_sem OK: sho_id:[%d]\n",tbl->sho_id);      
      }
      else {  /* Locked by task */
	DPRINT1("> (funlock) Locked by task:[%d] (no effect)\n",tbl->lock_owner);
      }
    }
  }

#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif
  DPRINT("> (funlock) return OK\n");
  return (0) ;
}

/************ Local functions *****************/

/*
   Get shared-object-information-table-address from Mailbox
*/
static ER
recv_solist_address ()

{
  T_MSG   *packet ;
  MSG_SHO  recv ;
  ER  ercd ;

  DPRINT("> (rsa) Enter: recv_solist_address:\n");

  /* Get (rcv) address of sho_list */
  if ((ercd = rcv_msg (&packet, JTI_MBX_ID_SHOBJ)) != E_OK) {
    DPRINT1("> (rsa) Err: rcv_msg: [%d]\n", ercd) ;
    return (ercd) ; 
  }
  DPRINT("> (rsa) recv_msg:[3] OK\n") ;
  memcpy (&recv, packet, sizeof(MSG_SHO)) ;
  p_sho_list = recv.solist ;
  DPRINT1("> (rsa) p_sho_list:[%d]\n",p_sho_list) ;

  DPRINT1("> (rsa) recv_solist_address: Return=[%d]\n",E_OK);
  return (E_OK) ;
}

/*
   Search table by name
*/
static SHO_TBL *
search_table_name (char *objnm)
{
  SHO_TBL  *tbl = NULL ;
  SHO_TBL  *prev_tbl = NULL ;

  DPRINT("> (stn) Enter: search_table_name\n");

  /* Search table by name */
  for (tbl = sho_list; tbl != NULL; tbl = tbl->next) {
    if (strcmp (tbl->name, objnm) == 0)  break ;
    prev_tbl = tbl ;
  }
  DPRINT4("$ (stn) sho_list[%d],tbl[%d],next[%d],prev[%d]\n",sho_list,tbl,tbl->next,prev_tbl);
  DPRINT("> (stn) return OK\n");
  return (tbl) ; 
}

/*
   Set Lock-status to table
*/
static void
SetLock (SHO_TBL *table, ID task_id, INT stat)
{
  table->lock_stat = stat ;
  table->lock_owner = task_id ;
}
/*
   Set Unlock-status to table
*/
static void
SetUnlock (SHO_TBL *table)
{
  table->lock_stat = UNLOCK ;
  table->lock_owner = 0 ;
}

#ifdef JTRON_DEBUG
/*
   Print all tables
*/
static void
print_all_tables ()
{
  SHO_TBL *tbl ;

  printf ("\n# Print all tables => START\n");
  for (tbl = sho_list; tbl != NULL; tbl = tbl->next) {
    printf ("\n# TBL:sho_id:[%d],name:[%s],owner:[%d],lock_stat:[%d],env:[%d],obj:[%d]\n",
	   tbl->sho_id,tbl->name,tbl->lock_owner,tbl->lock_stat,
	   tbl->jni_env,tbl->jni_obj);
  }
  printf ("# ==> END\n\n");
}

/*
   Print current table
*/
static void
print_cur_table (SHO_TBL *tbl)
{ 
  printf ("\n# Print current table => START\n");
  printf ("\n# TBL:sho_id:[%d],name:[%s],owner:[%d],lock_stat:[%d],env:[%d],obj:[%d]\n",
	   tbl->sho_id,tbl->name,tbl->lock_owner,tbl->lock_stat,
	   tbl->jni_env,tbl->jni_obj);
  printf ("# ==> END\n\n");
}
#endif /* JTRON_DEBUG */

#ifdef __cplusplus
}
#endif
