/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: jti_shared_object.c
   Note: JTRON 2.0 Shared Object Interface ITRON API (standard)
	 (Java Shared-object access)
	 ĥǽ⥸塼 (jt2ext)
   Date: 1999/8/11
   Last update: 2000/3/6
*/
#include <basic.h>
#include <bstring.h>
#include "if_jt2ext.h"

#include "jti_common.h"
#include "jti_shared.h"
#include "jti_debug.h"

#ifdef JTRON_DEBUG
#include <bsys/bms.h>
#define DSTR_LEN      128
#define DBPRINT(fmt)  _PutString(fmt)
#define DSPRINT1(buf,fmt,a)  sprintf(buf,fmt,a)
#define DSPRINT2(buf,fmt,a,b)  sprintf(buf,fmt,a,b)
#define DSPRINT3(buf,fmt,a,b,c)  sprintf(buf,fmt,a,b,c)
#define DSPRINT4(buf,fmt,a,b,c,d)  sprintf(buf,fmt,a,b,c,d)
void print_all_tables () ;
void print_cur_table () ;
#else
#define DBPRINT(fmt)
#define DSPRINT1(buf,fmt,a)
#define DSPRINT2(buf,fmt,a,b)
#define DSPRINT3(buf,fmt,a,b,c)
#define DSPRINT4(buf,fmt,a,b,c,d)
#endif /* JTRON_DEBUG */

#ifdef __cplusplus
extern "C" {
#endif

/* ֥ͭȴơ֥ꥹ */
SHO_TBL  *sho_list = NULL ;

/* ֥ͭȴơ֥ꥹȤΥݥѥѥå */
MSG_SHO  packet ;

/* Local functions */
LOCAL SHO_TBL *search_table_name () ;
LOCAL SHO_TBL *search_table_id () ;
LOCAL void SetLock();
LOCAL void SetUnlock();

/*
   Function: _jti_get_obj
   Note: Get Java shared-object ID by name
*/
EXPORT ER
_jti_get_obj (objnm, p_objno) 

char *objnm ;	 /* (I) Java shared-object name */
JNO  *p_objno ;	 /* (O) Shared-object ID */
{
  SHO_TBL  *tbl = NULL ;
#ifdef JTRON_DEBUG
  char  dstr[DSTR_LEN] ;
#endif

  dis_dsp () ;
  DSPRINT2(dstr,"\n$ (jgo) => _jti_get_obj: objnm=[%s], p_objno=[%d]\n",objnm,*p_objno);
  DBPRINT(dstr);

  if (objnm == NULL)  return (E_PAR) ;
  if (strlen (objnm) > JTI_MAX_SO_NAME)  return (E_PAR) ;

#ifdef JTRON_DEBUG
  print_all_tables () ;
#endif
  /* Search table by name */
  if ((tbl = search_table_name (objnm)) == NULL) {
    DSPRINT1(dstr,"$ (jgo) objnme:[%s] not found\n",objnm);
    DBPRINT(dstr);
    return (E_OBJ) ;  /* Target table not found */
  }
  DSPRINT1(dstr,"$ (jgo) name:[%s] found\n",objnm);
  DBPRINT(dstr);
#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif

  /* Get shared-object ID */
  *p_objno = tbl->sho_id ;

  DSPRINT2(dstr,"$ (jgo) _jti_get_obj: Return=[%d], p_objno=[%d]\n",E_OK,*p_objno);
  DBPRINT(dstr);
  ena_dsp () ;
  return (E_OK) ;
}

/*
   Function: _jti_get_mem
   Note: Get address of Java shared-object
*/
EXPORT ER
_jti_get_mem (objno, p_addr) 

JNO  objno ;	    /* (I) Java thread ID */
JNI_PTR  *p_addr ;  /* (O) JNI interface pointer */
{
  SHO_TBL  *tbl = NULL ;
  ID  t_id = 0 ;
  ER  ercd ;
#ifdef JTRON_DEBUG
  char  dstr[DSTR_LEN] ;
#endif

  dis_dsp () ;
  DSPRINT3(dstr,"\n$ (jgm) => _jti_get_mem: objno=[%d], p_addr->env=[%d], p_addr->obj=[%d]\n",objno,p_addr->env,p_addr->obj);
  DBPRINT(dstr);

  if (objno < 1)  return (E_PAR) ;

  /* Search table by ID */
  if ((tbl = search_table_id (objno)) == NULL) {
    DSPRINT1(dstr,"$ (jgm) objno:[%d] not found\n",objno);
    DBPRINT(dstr);
    return (E_OBJ) ;  /* Target table not found */
  }
  DSPRINT1(dstr,"$ (jgm) objno:[%d] found\n",objno);
  DBPRINT(dstr);
#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif

  /* Get task ID */
  if ((ercd = get_tid (&t_id)) < 0) {
    DSPRINT1(dstr,"$ (jgm) get_tid Err:[%d]\n",ercd);
    DBPRINT(dstr);
    return (E_SYS) ;  /* Err: get_tid */
  }
  DSPRINT1(dstr,"$ (jgm) get_tid OK:[%d]\n",t_id);
  DBPRINT(dstr);

  if (tbl->lock_stat == UNLOCK || tbl->lock_owner != t_id) {
    DBPRINT("$ (jgm) Err: not locked by this task\n");
    return (E_UNLOCKED) ;  /* Err: not locked by this task */
  }

  /* Get JNI interface pointer */
  p_addr->env = tbl->jni_env ;
  p_addr->obj = tbl->jni_obj ;

  DSPRINT3(dstr,"$ (jgm) _jti_get_mem: Return=[%d], p_addr->env=[%d], p_addr->obj=[%d]\n",E_OK,p_addr->env,p_addr->obj); 
  DBPRINT(dstr); 
  ena_dsp () ;
  return (E_OK) ;
}

/*
   Function: _jti_loc_obj
   Note: Lock Java shared-object
*/
EXPORT ER
_jti_loc_obj (objno, tmout) 

JNO  objno ;	 /* (I) Java shared-object ID */
TMO  tmout ;     /* (I) Timeout (ms) */  
{
  SHO_TBL  *tbl = NULL ;
  ID  t_id = 0 ;
  ER  ercd ;
#ifdef JTRON_DEBUG
  char  dstr[DSTR_LEN] ;
#endif

  dis_dsp () ;
  DSPRINT2(dstr,"\n$ (jlo) => _jti_loc_obj: objno=[%d], tmout=[%d]\n",objno,tmout);
  DBPRINT(dstr);

  if (objno < 1)  return (E_PAR) ;

  /* Search table by ID */
  if ((tbl = search_table_id (objno)) == NULL) {
    DSPRINT1(dstr,"$ (jlo) objno:[%d] not found\n",objno);
    DBPRINT(dstr);
    return (E_OBJ) ;  /* Target table not found */
  }
  DSPRINT1(dstr,"$ (jlo) objno:[%d] found\n",objno);
  DBPRINT(dstr);
#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif

  /* Get task ID */
  if ((ercd = get_tid (&t_id)) < 0) {
    DSPRINT1(dstr,"$ (jlo) get_tid Err:[%d]\n",ercd);
    DBPRINT(dstr);
    return (E_SYS) ;  /* Err: get_tid */
  }
  DSPRINT1(dstr,"$ (jlo) get_tid OK:[%d]\n",t_id);
  DBPRINT(dstr);

  if (tbl->lock_stat == UNLOCK) {  /* Unlocked */
    DBPRINT("\n$ (jlo) Unlocked");

    /* Get semapho (timeout) */
    ena_dsp () ;
    if ((ercd = twai_sem ((ID)(tbl->sho_id), tmout)) < 0) {
      DSPRINT2(dstr,"$ (jlo) twai_sem Err:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
      DBPRINT(dstr);
      return (ercd) ;  /* Err: twai_sem */
    }
    dis_dsp () ;
    DSPRINT1(dstr,"$ (jlo) twai_sem OK: sho_id:[%d]\n",tbl->sho_id);
    DBPRINT(dstr);

    /* Lock */
    SetLock (tbl, t_id, LOCK_TASK) ;
  }
  else {  /* Locked */
    if (tbl->lock_owner == t_id) {  /* Locked by this task */
      DBPRINT("$ (jlo) Locked by this task (no effect)\n");
    }
    else {  /* Locked by other task or thread */
      DSPRINT1(dstr,"$ (jlo) Locked by other task or thread: [%d]\n",tbl->lock_owner);
      DBPRINT(dstr);

      /* Get semapho (timeout) */
      ena_dsp () ;
      if ((ercd = twai_sem ((ID)(tbl->sho_id), tmout)) < 0) {
	DSPRINT2(dstr,"$ (jlo) twai_sem Err:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
	DBPRINT(dstr);
	return (ercd) ;  /* Err: twai_sem */
      }
      dis_dsp () ;
      DSPRINT1(dstr,"$ (jlo) twai_sem OK: sho_id:[%d]\n",tbl->sho_id);
      DBPRINT(dstr);

      /* Lock */
      SetLock (tbl, t_id, LOCK_TASK) ;
    }
  }
#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif
  DSPRINT1(dstr,"$ (jlo) _jti_loc_obj: Return=[%d]\n",E_OK); 
  DBPRINT(dstr);
  ena_dsp () ;
  return (E_OK) ;
}

/*
   Function: _jti_unl_obj
   Note: Unlock Java shared-object
*/
EXPORT ER
_jti_unl_obj (objno) 

JNO  objno ;	 /* (I) Java shared-object ID */
{
  SHO_TBL  *tbl = NULL ;
  ID  t_id = 0 ;
  ER  ercd = 0 ;
#ifdef JTRON_DEBUG
  char  dstr[DSTR_LEN] ;
#endif

  dis_dsp () ;
  DSPRINT1(dstr,"\n$ (juo) => _jti_unl_obj: objno=[%d]\n",objno);
  DBPRINT(dstr);

  if (objno < 1)  return (E_PAR) ;

  /* Search table by ID */
  if ((tbl = search_table_id (objno)) == NULL) {
    DSPRINT1(dstr,"$ (juo) objno:[%d] not found\n",objno);
    DBPRINT(dstr);
    return (E_OBJ) ;  /* Target table not found */
  }
  DSPRINT1(dstr,"$ (juo) objno:[%d] found\n",objno);
  DBPRINT(dstr);
#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif

  /* Get task ID */
  if ((ercd = get_tid (&t_id)) < 0) {
    DSPRINT1(dstr,"$ (juo) get_tid Err:[%d]\n",ercd);
    DBPRINT(dstr);
    return (E_SYS) ;  /* Err: get_tid */
  }
  DSPRINT1(dstr,"$ (juo) get_tid OK:[%d]\n",t_id);
  DBPRINT(dstr);

  if (tbl->lock_stat == UNLOCK) {  /* Unlocked */
    DBPRINT("$ (juo) Unlocked (no effect)\n");
  }
  else {  /* Locked */
    if (tbl->lock_owner == t_id) {  /* Locked by this task */
      DBPRINT("\n$ (juo) Locked by this task:");

      /* Unlock */
      SetUnlock (tbl) ;

      /* Return semapho */
      if ((ercd = sig_sem ((ID)(tbl->sho_id))) < 0) {
	DSPRINT2(dstr,"$ (juo) sig_sem Err:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
	DBPRINT(dstr);
	return (E_SYS) ;  /* Err: sig_sem */
      }
      DSPRINT1(dstr,"$ (juo) sig_sem OK: sho_id:[%d]\n",tbl->sho_id);      
    }
    else {  /* Locked by other thread or task */
      DSPRINT1(dstr,"$ (juo) Locked by other thread or task: [%d]\n",tbl->lock_owner);
      DBPRINT(dstr);
      return (E_OBJ) ;  /* Err: Locked by other task or thread */
    }
  }

#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif
  DSPRINT1(dstr,"$ (juo) _jti_unl_obj: Return=[%d]\n",E_OK); 
  DBPRINT(dstr);
  ena_dsp () ;
  return (E_OK) ;
}

/*
   Function: _jti_funl_obj
   Note: Force unlock Java shared-object
*/
EXPORT ER
_jti_funl_obj (objno) 

JNO  objno ;	 /* (I) Java shared-object ID */
{
  SHO_TBL  *tbl = NULL ;
  ER  ercd ;
#ifdef JTRON_DEBUG
  char  dstr[DSTR_LEN] ;
#endif

  dis_dsp () ;
  DBPRINT("\n$ => _jti_funl_obj\n");

  if (objno < 1)  return (E_PAR) ;

  /* Search table by ID */
  if ((tbl = search_table_id (objno)) == NULL) {
    DSPRINT1(dstr,"$ (jfuo) objno:[%d] not found\n",objno);
    DBPRINT(dstr);
    return (E_OBJ) ;  /* Target table not found */
  }
  DSPRINT1(dstr,"$ (jfuo) objno:[%d] found\n",objno);
  DBPRINT(dstr);
#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif

  if (tbl->lock_stat == UNLOCK) {  /* Unlocked */
    DBPRINT("$ (jfuo) Unlocked (no effect)\n");
  }
  else {  /* Locked */
    DBPRINT("$ (jfuo) Locked\n");

    /* Unlock */
    SetUnlock (tbl) ;

    /* Return semapho */
    if ((ercd = sig_sem ((ID)(tbl->sho_id))) < 0) {
      DSPRINT2(dstr,"$ (jfuo) sig_sem Err:[%d],sho_id:[%d]\n",ercd,tbl->sho_id);
      DBPRINT(dstr);
      return (E_SYS) ;  /* Err: sig_sem */
    }
    DSPRINT1(dstr,"$ (jfuo) sig_sem OK: sho_id:[%d]\n",tbl->sho_id);      
    DBPRINT(dstr);
  }

#ifdef JTRON_DEBUG
  print_cur_table (tbl) ;
#endif
  DBPRINT("$ (jfuo) return OK\n");

  ena_dsp () ;
  return (E_OK) ;
}

/*
   ֥ͭȤν / λ
*/
EXPORT ER
init_object (Bool StartUp)
{
  T_CMBX   pk_cmbx ;
  ER       ercd ;
#ifdef JTRON_DEBUG
  char  dstr[DSTR_LEN] ;
#endif

  DSPRINT1(dstr,"\n$ (io) => init_object: StartUp=[%d]\n",StartUp);
  DBPRINT(dstr);

  if (StartUp == True) {  /*  */
    /* ֥ͭȡᥤܥå (FIFO) */
    pk_cmbx.mbxatr = TA_MFIFO ;
    if ((ercd = cre_mbx (JTI_MBX_ID_SHOBJ, &pk_cmbx)) != E_OK) {
      DBPRINT("$ (io) Err: cre_mbx:[3]\n") ;
      return (ercd) ;
    }
    DBPRINT("$ (io) cre_mbx:[3] OK\n") ;

    /* ֥ͭȴ¤ΥꥹȤΡ֥ɥ쥹פ */
    packet.solist = &sho_list ;
    DSPRINT1(dstr,"$ (io) packet.solist:[%d]\n",(int)packet.solist);
    DBPRINT(dstr);

    if ((ercd = snd_msg (JTI_MBX_ID_SHOBJ, (T_MSG *)&packet)) != E_OK) {
      DBPRINT("$ (io) Err: snd_msg:[3]\n");
      return (ercd) ;
    }
    DBPRINT("$ (io) snd_msg:[3] OK\n") ;
  } else {  /* λ */
    /* ᥤܥå */
    del_mbx (JTI_MBX_ID_SHOBJ) ;
    DBPRINT("$ (io) del_mbx:[3] OK\n") ;
  }
  DSPRINT1(dstr,"$ (io) init_object: Return=[%d]\n",E_OK);
  DBPRINT(dstr);
  return (E_OK) ;
}

/**************** Local functions *****************/

/*
   Search table by name
*/
LOCAL SHO_TBL *
search_table_name (char *objnm)
{
  SHO_TBL  *tbl = NULL ;
  SHO_TBL  *prev_tbl = NULL ;
#ifdef JTRON_DEBUG
  char  dstr[DSTR_LEN] ;
#endif

  DBPRINT("\n$ => search_table_name\n");

  /* Search table by name */
  for (tbl = sho_list; tbl != NULL; tbl = tbl->next) {
    if (strcmp (tbl->name, objnm) == 0)  break ;
    prev_tbl = tbl ;
  }
#ifdef JTRON_DEBUG
  if (tbl != NULL) {
    DSPRINT4(dstr,"$ (stn) soh_list:[%d],tbl:[%d],next:[%d],prev:[%d]\n",
	     (int)sho_list,(int)tbl,(int)(tbl->next),(int)prev_tbl);
    DBPRINT(dstr);
  }
#endif
  return (tbl) ; 
}

/*
   Search table by ID
*/
LOCAL SHO_TBL *
search_table_id (JNO objno)
{
  SHO_TBL  *tbl = NULL ;
  SHO_TBL  *prev_tbl = NULL ;
#ifdef JTRON_DEBUG
  char  dstr[DSTR_LEN] ;
#endif

  DBPRINT("\n$ => search_table_id\n");

  for (tbl = sho_list; tbl != NULL; tbl = tbl->next) {
    if (tbl->sho_id == objno)  break ;
    prev_tbl = tbl ;
  }
#ifdef JTRON_DEBUG
  if (tbl != NULL) {
    DSPRINT4(dstr,"$ (sti) soh_list:[%d],tbl:[%d],next:[%d],prev:[%d]\n",
	     (int)sho_list,(int)tbl,(int)(tbl->next),(int)prev_tbl);
    DBPRINT(dstr);
  }
#endif
  return (tbl) ; 
}

/*
   Set Lock-status to table
*/
LOCAL void
SetLock (SHO_TBL *table, ID task_id, INT stat)
{
  DBPRINT("\n$ => SetLock\n");

  table->lock_stat = stat ;
  table->lock_owner = task_id ;
}
/*
   Set Unlock-status to table
*/
LOCAL void
SetUnlock (SHO_TBL *table)
{
  DBPRINT("\n$ => SetUnlock\n");

  table->lock_stat = UNLOCK ;
  table->lock_owner = 0 ;
}

#ifdef JTRON_DEBUG
/*
   Print all tables
*/
void
print_all_tables ()
{
  SHO_TBL *tbl ;
  char dstr[256] ;

  _PutString ("\n# Print all tables => START\n");
  for (tbl = sho_list; tbl != NULL; tbl = tbl->next) {
    sprintf (dstr, "# TBL: sho_id:[%d],name:[%s],owner:[%d],lock_stat:[%d],env:[%d],obj:[%d]\n",
	    tbl->sho_id,tbl->name,tbl->lock_owner,tbl->lock_stat,
	     (int)(tbl->jni_env),(int)(tbl->jni_obj));
    _PutString (dstr) ;
  }
  _PutString ("# ==> END\n\n");
}

/*
   Print current table
*/
void
print_cur_table (SHO_TBL *tbl)
{
  char dstr[256] ;

  _PutString ("\n# Print current table => START\n");
  sprintf (dstr,"# TBL: sho_id:[%d],name:[%s],owner:[%d],lock_stat:[%d],env:[%d],obj:[%d]\n",
	  tbl->sho_id,tbl->name,tbl->lock_owner,tbl->lock_stat,
	   (int)(tbl->jni_env),(int)(tbl->jni_obj));
  _PutString (dstr) ;
  _PutString ("# ==> END\n\n");
}
#endif /* JTORN_DEBUG */

#ifdef __cplusplus
}
#endif
