/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: jti_shared_thgroup.c
   Note: JTRON 2.0 Shared Object Interface ITRON API
         (Call Java ThreadGroup class method)
   Date: 1999/8/7
   Last update: 2000/3/6
*/
#include <basic.h>
#include <bstring.h>
#include "if_jt2ext.h"

#include "jti_common.h"
#include "jti_shared.h"
#include "jti_debug.h"

#ifdef __cplusplus
extern "C" {
#endif

/*
   Function: _jti_get_tgr
   Note: Get thread group ID by name
*/
EXPORT ER
_jti_get_tgr (tgrnm, p_tgrno) 

char *tgrnm ;	/* (I) Java thread group name */
JNO  *p_tgrno ;	/* (O) Java thread group ID */
{
  MSG_SEND_NAME  send ;
  MSG_RECV       recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (get_tg) _jti_get_tgr");
  DPRINT2("$ tgrnm=[%s], p_tgrno=[%d]\n",tgrnm,*p_tgrno);

  if (tgrnm == NULL)  return (E_PAR) ;
  if (strlen (tgrnm) > JTI_MAX_THREAD_NAME)  return (E_PAR) ;

  /* Make massage */
  send.kind = IA_TGR_GET_ID ;
  send.len = (INT)strlen (tgrnm) + 1 ;
  strcpy (send.name, tgrnm) ;
  DPRINT3("$ (get_tg) Send: kind:[%d], len:[%d], name:[%s]\n",send.kind,send.len,send.name);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (get_tg) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT2("$ (get_tg) Reply: ercd:[%d], jpri(p_tgrno):[%d]\n",recv.ercd,recv.jpri);
  *p_tgrno = (JNO)recv.jpri ;  /* ThreadGroup ID */

  DPRINT2("$ _jti_get_tgr: Return=[%d], p_tgrno=[%d]\n",recv.ercd,*p_tgrno);
  return ((ER_BOOL)recv.ercd) ;
}

/*
   Function: _jti_sus_tgr
   Note: Call ThreadGroup.suspend method
*/
EXPORT ER
_jti_sus_tgr (tgrno) 

JNO  tgrno ;	/* (I) Java thread group ID */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (sus_tg) _jti_sus_tgr");
  DPRINT1("$ tgrno=[%d]\n",tgrno);

  /* Make massage */
  send.kind = IA_TGR_SUS ;
  send.id = tgrno ;
  send.jpri = 0 ;
  DPRINT2("$ (sus_tg) Send: kind:[%d], id:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (sus_tg) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (sus_tg) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_sus_tgr: Return=[%d]\n",recv.ercd);
  return ((ER)recv.ercd) ;
}

/*
   Function: _jti_rsm_tgr
   Note: Call ThreadGroup.resume method
*/
EXPORT ER
_jti_rsm_tgr (tgrno) 

JNO  tgrno ;	/* (I) Java thread group ID */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (rsm_tg) _jti_rsm_tgr");
  DPRINT1("$ tgrno=[%d]\n",tgrno);

  /* Make massage */
  send.kind = IA_TGR_RSM ;
  send.id = tgrno ;
  send.jpri = 0 ;
  DPRINT3("$ (rsm_tg) Send: kind:[%d], id:[%d], jpri:[%d]\n",send.kind,send.id,send.jpri);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (rsm_tg) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (rsm_tg) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_rsm_tgr: Return=[%d]\n",recv.ercd);
  return ((ER)recv.ercd) ;
}

/*
   Function: _jti_stp_tgr
   Note: Call ThreadGroup.stop method
*/
EXPORT ER
_jti_stp_tgr (tgrno) 

JNO  tgrno ;	/* (I) Java thread group ID */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (stp_tg) _jti_stp_tgr");
  DPRINT1("$ tgrno=[%d]\n",tgrno);

  /* Make massage */
  send.kind = IA_TGR_STP ;
  send.id = tgrno ;
  send.jpri = 0 ;
  DPRINT2("$ (stp_tg) Send: kind:[%d], id:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (stp_tg) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (stp_tg) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_stp_tgr: Return=[%d]\n",recv.ercd);
  return ((ER)recv.ercd) ;
}

/*
   Function: _jti_des_tgr
   Note: Call ThreadGroup.destroy method
*/
EXPORT ER
_jti_des_tgr (tgrno) 

JNO  tgrno ;	/* (I) Java thread group ID */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (des_tg) _jti_des_tgr");
  DPRINT1("$ tgrno=[%d]\n",tgrno);

  /* Make massage */
  send.kind = IA_TGR_DES ;
  send.id = tgrno ;
  send.jpri = 0 ;
  DPRINT2("$ (des_tg) Send: kind:[%d], id:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (des_tg) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (des_tg) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_des_tgr: Return=[%d]\n",recv.ercd);
  return ((ER)recv.ercd) ;
}

#ifdef __cplusplus
}
#endif
