/*
 *  JCG Products Ver 1.00.00
 *
 *  Copyright (C) 2000,2001 TRON Association
 *  All rights reserved.
 *  Copyright (C) 2000,2001 Information-technology Promotion Agency, Japan
 *  All rights reserved.
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡۡ
 *ƵͿݰơʰʲۤȤˤ뤳Ȥ̵ǵ
 *롥
 *  (1) ܥեȥ򥽡ɤηǺۤˤϡ嵭
 *      ɽκ۾浪Ӳ̵ݾڵ꤬
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򥪥֥ȥɤηޤϵȤ߹
 *      ǺۤˤϡΤ줫ξȡ
 *        ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *          ɽκ۾浪Ӳ̵ݾڵǺܤ
 *          ȡ
 *        ܥեȥѤȤˤäľŪޤϴŪ
 *          ʤ»⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤȤˤäľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  The Copyrights Holder above agrees that this software (including the
 *  Derivative work of this software. This is applicable hereinafter) is
 *  used, copied, modified, distributed, sent, re-granted, lent or adopted
 *  (hereinafter called "redistribution") for free as long as the
 *  following License Conditions are satisfied.
 *    (1) If this software is to be redistributed in the form of source
 *        codes, Copyright Notice above, this redistribution conditions,
 *        and the following NO WARRANTY Provisions must be included in
 *        the source code.
 *    (2) If this software is to be redistributed in the form of object
 *        codes or integrated into a device, either of the following
 *        conditions must be satisfied.
 *         - Copyright Notice above, this redistribution conditions, and
 *           the following NO WARRANTY Provisions appear in the attached
 *           document (such as users manual).
 *         - Copyrights Holder above is exempted from any direct/indirect
 *           damages caused as a result of using this software.
 *
 *  This software is provided with NO WARRANTY. Copyrights Holder above
 *  provides NO WARRANTY on this software, including its applicability,
 *  and is not liable for any direct/indirect damages caused as a result
 *  of using this software.
 *
 *  NOTICE:
 *    Sentences above are translation for reference. For legal purposes,
 *    the original Japanese sentences on top of this file are the official
 *    sentences for License Conditions.
 */

/*
   File name: jti_shared_thread.c
   Note: JTRON 2.0 Shared Object Interface ITRON API
         (Call Java Thread class method)
   Date: 1999/8/7
   Last update: 2000/3/6
*/
#include <basic.h>
#include <bstring.h>
#include "if_jt2ext.h"

#include "jti_common.h"
#include "jti_shared.h"
#include "jti_debug.h"

#ifdef __cplusplus
extern "C" {
#endif

/*
   Function: _jti_get_thr
   Note: Get Java thread ID by name
*/
EXPORT ER
_jti_get_thr (thrnm, p_thrno) 

char *thrnm ;	/* (I) Java thread name */
JNO  *p_thrno ;	/* (O) Java thread ID */
{
  MSG_SEND_NAME  send ;
  MSG_RECV       recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (get_th) _jti_get_thr");
  DPRINT2("$ thrnm=[%s], p_thrno=[%d]\n",thrnm,*p_thrno);

  if (thrnm == NULL)  return (E_PAR) ;
  if (strlen (thrnm) > JTI_MAX_THREAD_NAME)  return (E_PAR) ;

  /* Make massage */
  send.kind = IA_THR_GET_ID ;
  send.len = (INT)strlen (thrnm) + 1 ;
  strcpy (send.name, thrnm) ;
  DPRINT3("$ (get_th) Send: kind:[%d], len:[%d], name:[%s]\n",send.kind,send.len,send.name);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (get_th) Err: snd_msg:[%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT2("$ (get_th) Reply: ercd:[%d], jpri(p_thrno):[%d]\n",recv.ercd,recv.jpri);
  *p_thrno = (JNO)recv.jpri ;  /* Thread ID */

  DPRINT2("$ _jti_get_thr: Return=[%d], p_thrno=[%d]\n",recv.ercd,*p_thrno);
  return ((ER_BOOL)recv.ercd) ;
}

/*
   Function: _jti_isa_thr
   Note: Call Java Thread.isAlive method
*/
EXPORT ER_BOOL
_jti_isa_thr (thrno) 

JNO  thrno ;	/* (I) Java thread ID */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (isa_th) _jti_isa_thr");
  DPRINT1("$ thrno=[%d]\n",thrno);

  /* Make massage */
  send.kind = IA_THR_ISA ;
  send.id = thrno ;
  send.jpri = 0 ;
  DPRINT2("$ (isa_th) Send: kind:[%d], id:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (isa_th) Err: snd_msg:[%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (isa_th) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_isa_thr: Return=[%d]\n",recv.ercd);
  return ((ER_BOOL)recv.ercd) ;
}

/*
   Function: _jti_int_thr
   Note: Call Java Thread.interrupt method
*/
EXPORT ER
_jti_int_thr (thrno) 

JNO  thrno ;	/* (I) Java thread ID */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (int_th) _jti_int_thr");
  DPRINT1("$ thrno=[%d]\n",thrno);

  /* Make massage */
  send.kind = IA_THR_INT ;
  send.id = thrno ;
  send.jpri = 0 ;
  DPRINT2("$ (int_th) Send: kind:[%d], id:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (int_th) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (int_th) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_int_thr: Return=[%d]\n",recv.ercd);
  return ((ER)recv.ercd) ;
}

/*
   Function: _jti_isi_thr
   Note: Call Java Thread.isInterrupted method
*/
EXPORT ER_BOOL
_jti_isi_thr (thrno) 

JNO  thrno ;	/* (I) Java thread ID */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (isi_th) _jti_isi_thr");
  DPRINT1("$ thrno=[%d]\n",thrno);

  /* Make massage */
  send.kind = IA_THR_ISI ;
  send.id = thrno ;
  send.jpri = 0 ;
  DPRINT2("$ (isi_th) Send: kind: [%d], id:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (isi_th) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (isi_th) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_isi_thr: Return=[%d]\n",recv.ercd);
  return ((ER_BOOL)recv.ercd) ;
}

/*
   Function: _jti_sus_thr
   Note: Call Java Thread.suspend method
*/
EXPORT ER
_jti_sus_thr (thrno) 

JNO  thrno ;	/* (I) Java thread ID */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (sus_th) _jti_sus_thr");
  DPRINT1("$ thrno=[%d]\n",thrno);

  /* Make massage */
  send.kind = IA_THR_SUS ;
  send.id = thrno ;
  send.jpri = 0 ;
  DPRINT2("$ (sus_th) Send: kind:[%d], id:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (sus_th) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (sus_th) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_sus_thr: Return=[%d]\n",recv.ercd);
  return ((ER)recv.ercd) ;
}

/*
   Function: _jti_rsm_thr
   Note: Call Java Thread.resume method
*/
EXPORT ER
_jti_rsm_thr (thrno) 

JNO  thrno ;	/* (I) Java thread ID */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (rsm_th) _jti_rsm_thr");
  DPRINT1("$ thrno=[%d]\n",thrno);

  /* Make massage */
  send.kind = IA_THR_RSM ;
  send.id = thrno ;
  send.jpri = 0 ;
  DPRINT2("$ (rsm_th) Send: kind:[%d], id:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (rsm_th) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (rsm_th) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_rsm_thr: Return=[%d]\n",recv.ercd);
  return ((ER)recv.ercd) ;
}

/*
   Function: _jti_sta_thr
   Note: Call Java Thread.start method
*/
EXPORT ER
_jti_sta_thr (thrno) 

JNO  thrno ;	/* (I) Java thread ID */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (sta_th) _jti_sta_thr");
  DPRINT1("$ thrno=[%d]\n",thrno);

  /* Make massage */
  send.kind = IA_THR_STA ;
  send.id = thrno ;
  send.jpri = 0 ;
  DPRINT2("$ (sta_th) Send: kind:[%d], id:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (sta_th) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (sta_th) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_sta_thr: Return=[%d]\n",recv.ercd);
  return ((ER)recv.ercd) ;
}

/*
   Function: _jti_thr_stp
   Note: Call Java Thread.stop method
*/
EXPORT ER
_jti_thr_stp (thrno) 

JNO  thrno ;	/* (I) Java thread ID */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (th_stp) _jti_thr_stp");
  DPRINT1("$ thrno=[%d]\n",thrno);

  /* Make massage */
  send.kind = IA_THR_STP ;
  send.id = thrno ;
  send.jpri = 0 ;
  DPRINT2("$ (th_stp) Send: kind:[%d], id:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (th_stp) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (th_stp) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_thr_stp: Return=[%d]\n",recv.ercd);
  return ((ER)recv.ercd) ;
}

/*
   Function: _jti_get_jpr
   Note: Call Java Thread.getPriority method
*/
EXPORT ER
_jti_get_jpr (thrno, p_rslt) 

JNO  thrno ;	/* (I) Java thread ID */
INT  *p_rslt ;	/* (O) Java thread priority */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (get_jpr) _jti_get_jpr");
  DPRINT2("$ thrno=[%d], p_rslt=[%d]\n",thrno,*p_rslt);

  /* Make massage */
  send.kind = IA_THR_GET_JPR ;
  send.id = thrno ;
  send.jpri = 0 ;
  DPRINT2("$ (get_jpr) Send: kind:[%d], id:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (get_jpr) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT2("$ (get_jpr) Reply: ercd:[%d], jpri:[%d]\n",recv.ercd,recv.jpri);
  *p_rslt = recv.jpri ;

  DPRINT2("$ _jti_get_jpr: Return=[%d], p_rslt=[%d]\n",recv.ercd,*p_rslt);
  return ((ER)recv.ercd) ;
}

/*
   Function: _jti_set_jpr
   Note: Call Java Thread.setPriority method
*/
EXPORT ER
_jti_set_jpr (thrno, newpri) 

JNO  thrno ;	/* (I) Java thread ID */
INT  newpri ;	/* (I) Java thread priority */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (set_jpr) _jti_set_jpr");
  DPRINT2("$ thrno=[%d], newpri=[%d]\n",thrno,newpri);

  /* Make massage */
  send.kind = IA_THR_SET_JPR ;
  send.id = thrno ;
  send.jpri = newpri ;
  DPRINT3("$ (set_jpr) Send: kind:[%d], id:[%d], jpri:[%d]\n",send.kind,send.id,send.jpri);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (set_jpr) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (set_jpr) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_set_jpr: Return=[%d]\n",recv.ercd);
  return ((ER)recv.ercd) ;
}

/*
   Function: _jti_des_thr
   Note: Call Java Thread.destroy method
*/
EXPORT ER
_jti_des_thr (thrno) 

JNO  thrno ;	/* (I) Java thread ID */
{
  MSG_SEND    send ;
  MSG_RECV    recv ;
  ER  er = E_OK ;

  TRACE_FUNC("$ (des_th) _jti_des_thr");
  DPRINT1("$ thrno=[%d]\n",thrno);

  /* Make massage */
  send.kind = IA_THR_DES ;
  send.id = thrno ;
  send.jpri = 0 ;
  DPRINT2("$ (des_th) Send: kind:[%d], id:[%d]\n",send.kind,send.id);

  /* Send message */
  if ((er = snd_msg (JTI_MBX_ID_THREAD, (T_MSG *)&send)) != E_OK) {
    DPRINT1("$ (des_th) Err: snd_msg: [%d]\n",er);
    return (er) ;
  }

  /* Read reply */
  memcpy (&recv, &send, sizeof(MSG_RECV)) ;
  DPRINT1("$ (des_th) Reply: ercd:[%d]\n",recv.ercd);

  DPRINT1("$ _jti_des_thr: Return=[%d]\n",recv.ercd);
  return ((ER)recv.ercd) ;
}

/*
   åν / λ
*/
EXPORT ER
init_thread (Bool StartUp)
{
  T_CMBX   pk_cmbx ;
  ER       ercd ;

  TRACE_FUNC("$ (i_th) init_thread");
  DPRINT1("$ StartUp=[%d]\n",StartUp);

  if (StartUp == True) {  /*  */
    /* ᥤܥå (FIFO) */
    pk_cmbx.mbxatr = TA_MFIFO ;
    if ((ercd = cre_mbx (JTI_MBX_ID_THREAD, &pk_cmbx)) != E_OK) {
      DPRINT1 ("$ (i_th) Err: cre_mbx:[%d]\n", ercd) ;
      return (ercd) ;
    }
    DPRINT1 ("$ (i_th) cre_mbx:[%d] OK\n",JTI_MBX_ID_THREAD) ;
  } else {  /* λ */
    /* ᥤܥå */
    del_mbx (JTI_MBX_ID_THREAD) ;
    DPRINT1 ("$ (i_th) del_mbx:[%d] OK\n",JTI_MBX_ID_THREAD) ;
  }

  DPRINT1("$ init_thread: Return=[%d]\n",E_OK);
  return (E_OK) ;
}

#ifdef __cplusplus
}
#endif
